# DashContentSteeringTracker

Artifact: [androidx.media3:media3-exoplayer-dash](https://developer.android.com/jetpack/androidx/releases/media3) [View Source](https://cs.android.com/search?q=file:androidx/media3/exoplayer/dash/DashContentSteeringTracker.java+class:androidx.media3.exoplayer.dash.DashContentSteeringTracker)

*** ** * ** ***


```
@UnstableApi
class DashContentSteeringTracker : BaseContentSteeringTracker
```

<br />

|---|---|---|
| [kotlin.Any](https://kotlinlang.org/api/core/kotlin-stdlib/kotlin/-any/index.html) |||
| ↳ | [androidx.media3.exoplayer.upstream.contentsteering.BaseContentSteeringTracker](https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/upstream/contentsteering/BaseContentSteeringTracker) ||
|   | ↳ | [androidx.media3.exoplayer.dash.DashContentSteeringTracker](https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/dash/DashContentSteeringTracker) |

*** ** * ** ***

Tracks the content steering states for a DASH stream.

## Summary

| ### Nested types |
|---|
| `interface https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/dash/DashContentSteeringTracker.Callback` A callback to be notified of `https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/dash/DashContentSteeringTracker` events. |
| `interface https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/dash/DashContentSteeringTracker.SteeringQueryParamsProvider` Provides the information for the query parameters to request the steering manifests. |

| ### Public constructors |
|---|
| `https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/dash/DashContentSteeringTracker#DashContentSteeringTracker(androidx.media3.datasource.DataSource.Factory,com.google.common.base.Supplier<androidx.media3.exoplayer.util.ReleasableExecutor>,androidx.media3.exoplayer.dash.DashContentSteeringTracker.Callback,androidx.media3.datasource.TransferListener,androidx.media3.exoplayer.dash.manifest.DashManifest)( dataSourceFactory: https://developer.android.com/reference/kotlin/androidx/media3/datasource/DataSource.Factory!, downloadExecutorSupplier: https://guava.dev/releases/snapshot-android/api/docs/com/google/common/base/Supplier.html<https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/util/ReleasableExecutor!>?, callback: https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/dash/DashContentSteeringTracker.Callback?, mediaTransferListener: https://developer.android.com/reference/kotlin/androidx/media3/datasource/TransferListener?, manifest: https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/dash/manifest/DashManifest! )` Creates a `https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/dash/DashContentSteeringTracker`. |

| ### Public functions |
|---|---|
| `https://kotlinlang.org/api/core/kotlin-stdlib/kotlin/-unit/index.html` | `https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/dash/DashContentSteeringTracker#addSteeringQueryParamsProvider(androidx.media3.exoplayer.dash.DashContentSteeringTracker.SteeringQueryParamsProvider)( provider: https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/dash/DashContentSteeringTracker.SteeringQueryParamsProvider! )` Adds a `https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/dash/DashContentSteeringTracker.SteeringQueryParamsProvider` to the tracker. |
| `https://guava.dev/releases/snapshot-android/api/docs/com/google/common/collect/ImmutableList.html<https://kotlinlang.org/api/core/kotlin-stdlib/kotlin/-string/index.html!>?` | `https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/dash/DashContentSteeringTracker#getCurrentServiceLocationPriority()()` Returns the current service location priority, or `null` if the tracker is inactive or no priority has been established. |
| `https://developer.android.com/reference/kotlin/androidx/media3/datasource/TransferListener!` | `https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/dash/DashContentSteeringTracker#getMediaTransferListener()()` Returns the `https://developer.android.com/reference/kotlin/androidx/media3/datasource/TransferListener` that should be used by the `https://developer.android.com/reference/kotlin/androidx/media3/datasource/DataSource` for media loading. |
| `https://kotlinlang.org/api/core/kotlin-stdlib/kotlin/-unit/index.html` | `https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/dash/DashContentSteeringTracker#removeSteeringQueryParamsProvider(androidx.media3.exoplayer.dash.DashContentSteeringTracker.SteeringQueryParamsProvider)( provider: https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/dash/DashContentSteeringTracker.SteeringQueryParamsProvider! )` Removes a `https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/dash/DashContentSteeringTracker.SteeringQueryParamsProvider` from the tracker. |
| `https://kotlinlang.org/api/core/kotlin-stdlib/kotlin/-unit/index.html` | `https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/dash/DashContentSteeringTracker#updateManifest(androidx.media3.exoplayer.dash.manifest.DashManifest)(manifest: https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/dash/manifest/DashManifest!)` Updates the `https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/dash/manifest/DashManifest` for the stream. |

| ### Protected functions |
|---|---|
| `https://guava.dev/releases/snapshot-android/api/docs/com/google/common/collect/ImmutableMap.html<https://kotlinlang.org/api/core/kotlin-stdlib/kotlin/-string/index.html!, https://kotlinlang.org/api/core/kotlin-stdlib/kotlin/-string/index.html!>!` | `https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/dash/DashContentSteeringTracker#getSteeringQueryParameters()()` Returns the query parameters to include in the steering manifest request. |
| `https://kotlinlang.org/api/core/kotlin-stdlib/kotlin/-boolean/index.html` | `https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/dash/DashContentSteeringTracker#isPathwayAvailable(java.lang.String)(pathwayId: https://kotlinlang.org/api/core/kotlin-stdlib/kotlin/-string/index.html!)` Returns whether the given pathway is currently available. |
| `https://kotlinlang.org/api/core/kotlin-stdlib/kotlin/-unit/index.html` | `https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/dash/DashContentSteeringTracker#onStart(com.google.common.collect.ImmutableList<java.lang.String>)(initialPathwayIds: https://guava.dev/releases/snapshot-android/api/docs/com/google/common/collect/ImmutableList.html<https://kotlinlang.org/api/core/kotlin-stdlib/kotlin/-string/index.html!>!)` Called when the tracker is started. |
| `https://kotlinlang.org/api/core/kotlin-stdlib/kotlin/-unit/index.html` | `https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/dash/DashContentSteeringTracker#onStop()()` Called when tracking is stopped. |
| `https://kotlinlang.org/api/core/kotlin-stdlib/kotlin/-unit/index.html` | `https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/dash/DashContentSteeringTracker#performPathwayClone(androidx.media3.exoplayer.upstream.contentsteering.SteeringManifest.PathwayClone)(pathwayClone: https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/upstream/contentsteering/SteeringManifest.PathwayClone!)` Performs a pathway clone defined in the steering manifest. |
| `https://kotlinlang.org/api/core/kotlin-stdlib/kotlin/-unit/index.html` | `https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/dash/DashContentSteeringTracker#performPathwayEvaluation(com.google.common.collect.ImmutableList<java.lang.String>)(pathwayPriority: https://guava.dev/releases/snapshot-android/api/docs/com/google/common/collect/ImmutableList.html<https://kotlinlang.org/api/core/kotlin-stdlib/kotlin/-string/index.html!>!)` Performs a pathway evaluation based on the passed pathway priority. |

### Inherited functions

From [androidx.media3.exoplayer.upstream.contentsteering.BaseContentSteeringTracker](https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/upstream/contentsteering/BaseContentSteeringTracker) `java-static https://developer.android.com/reference/android/net/Uri.html!` `https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/upstream/contentsteering/BaseContentSteeringTracker#applyUriReplacement(android.net.Uri,androidx.media3.exoplayer.upstream.contentsteering.SteeringManifest.UriReplacement)(
baseUri: https://developer.android.com/reference/android/net/Uri.html!,
uriReplacement: https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/upstream/contentsteering/SteeringManifest.UriReplacement!
)`

Applies a `https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/upstream/contentsteering/SteeringManifest.UriReplacement` to a base URI.
`https://kotlinlang.org/api/core/kotlin-stdlib/kotlin/-unit/index.html` `https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/upstream/contentsteering/BaseContentSteeringTracker#release()()`

Releases the Content Steering tracker.
`https://kotlinlang.org/api/core/kotlin-stdlib/kotlin/-unit/index.html` `https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/upstream/contentsteering/BaseContentSteeringTracker#start(android.net.Uri,com.google.common.collect.ImmutableList<java.lang.String>,androidx.media3.exoplayer.source.MediaSourceEventListener.EventDispatcher)(
initialSteeringManifestUri: https://developer.android.com/reference/android/net/Uri.html!,
initialPathwayIds: https://guava.dev/releases/snapshot-android/api/docs/com/google/common/collect/ImmutableList.html<https://kotlinlang.org/api/core/kotlin-stdlib/kotlin/-string/index.html!>!,
eventDispatcher: https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/source/MediaSourceEventListener.EventDispatcher!
)`

Starts the Content Steering tracker.

### Inherited properties

From [androidx.media3.exoplayer.upstream.contentsteering.BaseContentSteeringTracker](https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/upstream/contentsteering/BaseContentSteeringTracker) `https://guava.dev/releases/snapshot-android/api/docs/com/google/common/collect/ImmutableList.html<https://kotlinlang.org/api/core/kotlin-stdlib/kotlin/-string/index.html!>?` `https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/upstream/contentsteering/BaseContentSteeringTracker#currentPathwayPriority()` `https://kotlinlang.org/api/core/kotlin-stdlib/kotlin/-boolean/index.html` `https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/upstream/contentsteering/BaseContentSteeringTracker#isActive()`

## Public constructors

### DashContentSteeringTracker

```
DashContentSteeringTracker(
    dataSourceFactory: DataSource.Factory!,
    downloadExecutorSupplier: Supplier<ReleasableExecutor!>?,
    callback: DashContentSteeringTracker.Callback?,
    mediaTransferListener: TransferListener?,
    manifest: DashManifest!
)
```

Creates a `https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/dash/DashContentSteeringTracker`.

| Parameters |
|---|---|
| `dataSourceFactory: https://developer.android.com/reference/kotlin/androidx/media3/datasource/DataSource.Factory!` | The `https://developer.android.com/reference/kotlin/androidx/media3/datasource/DataSource.Factory`. |
| `downloadExecutorSupplier: https://guava.dev/releases/snapshot-android/api/docs/com/google/common/base/Supplier.html<https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/util/ReleasableExecutor!>?` | A supplier for a `https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/util/ReleasableExecutor`, or `null`. |
| `callback: https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/dash/DashContentSteeringTracker.Callback?` | A `https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/dash/DashContentSteeringTracker.Callback`. |
| `mediaTransferListener: https://developer.android.com/reference/kotlin/androidx/media3/datasource/TransferListener?` | The `https://developer.android.com/reference/kotlin/androidx/media3/datasource/TransferListener` to be used by the `https://developer.android.com/reference/kotlin/androidx/media3/datasource/DataSource` for media loading, which should be the `https://developer.android.com/reference/kotlin/androidx/media3/datasource/TransferListener` passed to the `https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/dash/DashMediaSource` when the source is prepared. |
| `manifest: https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/dash/manifest/DashManifest!` | The `https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/dash/manifest/DashManifest`. |

## Public functions

### addSteeringQueryParamsProvider

```
fun addSteeringQueryParamsProvider(
    provider: DashContentSteeringTracker.SteeringQueryParamsProvider!
): Unit
```

Adds a `https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/dash/DashContentSteeringTracker.SteeringQueryParamsProvider` to the tracker.

### getCurrentServiceLocationPriority

```
fun getCurrentServiceLocationPriority(): ImmutableList<String!>?
```

Returns the current service location priority, or `null` if the tracker is inactive or no priority has been established.

### getMediaTransferListener

```
fun getMediaTransferListener(): TransferListener!
```

Returns the `https://developer.android.com/reference/kotlin/androidx/media3/datasource/TransferListener` that should be used by the `https://developer.android.com/reference/kotlin/androidx/media3/datasource/DataSource` for media loading.

### removeSteeringQueryParamsProvider

```
fun removeSteeringQueryParamsProvider(
    provider: DashContentSteeringTracker.SteeringQueryParamsProvider!
): Unit
```

Removes a `https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/dash/DashContentSteeringTracker.SteeringQueryParamsProvider` from the tracker.

### updateManifest

```
fun updateManifest(manifest: DashManifest!): Unit
```

Updates the `https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/dash/manifest/DashManifest` for the stream.

## Protected functions

### getSteeringQueryParameters

```
protected fun getSteeringQueryParameters(): ImmutableMap<String!, String!>!
```

Returns the query parameters to include in the steering manifest request.

### isPathwayAvailable

```
protected fun isPathwayAvailable(pathwayId: String!): Boolean
```

Returns whether the given pathway is currently available.

| Parameters |
|---|---|
| `pathwayId: https://kotlinlang.org/api/core/kotlin-stdlib/kotlin/-string/index.html!` | The ID of the pathway to check. |

| Returns |
|---|---|
| `https://kotlinlang.org/api/core/kotlin-stdlib/kotlin/-boolean/index.html` | Whether the given pathway is available. |

### onStart

```
protected fun onStart(initialPathwayIds: ImmutableList<String!>!): Unit
```

Called when the tracker is started.

| Parameters |
|---|---|
| `initialPathwayIds: https://guava.dev/releases/snapshot-android/api/docs/com/google/common/collect/ImmutableList.html<https://kotlinlang.org/api/core/kotlin-stdlib/kotlin/-string/index.html!>!` | The IDs of the initial pathways to be used before the first steering manifest is loaded. |

### onStop

```
protected fun onStop(): Unit
```

Called when tracking is stopped.

This can be either externally called by `https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/upstream/contentsteering/BaseContentSteeringTracker#release()` or internally due to an unrecoverable error.

### performPathwayClone

```
protected fun performPathwayClone(pathwayClone: SteeringManifest.PathwayClone!): Unit
```

Performs a pathway clone defined in the steering manifest.

| Parameters |
|---|---|
| `pathwayClone: https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/upstream/contentsteering/SteeringManifest.PathwayClone!` | The `https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/upstream/contentsteering/SteeringManifest.PathwayClone` to perform. |

### performPathwayEvaluation

```
protected fun performPathwayEvaluation(pathwayPriority: ImmutableList<String!>!): Unit
```

Performs a pathway evaluation based on the passed pathway priority.

| Parameters |
|---|---|
| `pathwayPriority: https://guava.dev/releases/snapshot-android/api/docs/com/google/common/collect/ImmutableList.html<https://kotlinlang.org/api/core/kotlin-stdlib/kotlin/-string/index.html!>!` | The `https://developer.android.com/reference/kotlin/androidx/media3/exoplayer/upstream/contentsteering/SteeringManifest#pathwayPriority()` to use for evaluation. |